-------------------------------------------
-- © 2020 Brad Dunbar, All rights reserved.
-------------------------------------------
	-- if Debugging == true then  printDebug ( "EventHandler" , ATCtarget, 10 ) end

-- EVENT LOOP FOR PLAYER FLYING TO TARGET
if 	TargetHold.spawnposition ~= nil and TargetHold.visible == nil and PlayerAlive == true then
	-- if Debugging == true then  printDebug ( "EventHandler" , "Target Event Loop", 10 ) end
		if TargetHold.follow == nil then 
			myDistanceToTarget = getDistanceBetweenPoint( PlayerName, TargetHold.spawnposition.x , TargetHold.spawnposition.z )		
		elseif  WingmanAlive == true then
			myDistanceToTarget = getDistanceBetweenPoint( Wingman, TargetHold.spawnposition.x , TargetHold.spawnposition.z )	
		end 
	
	--if Debugging == true then  printDebug ( "EventHandler" , PlayerName  .. " distance from: " .. TargetHold.callsign .. " is " .. myDistanceToTarget, 10 ) end
	local oneMinuteDelay  = math.fmod (timer.getTime(), 60 ) 
			
	if oneMinuteDelay < 1 then

		
		TargetHold.distance = getDistanceBetweenPoint( PlayerName, TargetHold.spawnposition.x , TargetHold.spawnposition.z )		
		TargetHold.bearing = getBearingToPoint(PlayerName , TargetHold.spawnposition)
		local myTargetAltString = "Altitude\ " .. string.format("%d", TargetHold.alt) .. " " .. PlayerAircraft.altimeter:sub(1,1):upper() .. PlayerAircraft.altimeter:sub(2) .. " MSL " 
		
				-- which units are still alive
		ATCtarget = nil -- start out no targets are active
		if Group.getByName(TargetName) ~= nil then --at least one target is alive
			for index, data in pairs(Group.getByName(TargetName):getUnits()) do	
				local myLivingUnit = Unit.getName(data)	
				if myLivingUnit == TargetName .. TargetCallsigns[1] and ATCtarget == nil then 
					ATCtarget = myLivingUnit
				elseif myLivingUnit == TargetName .. TargetCallsigns[2] and ATCtarget == nil then 
					ATCtarget = myLivingUnit
				elseif myLivingUnit == TargetName .. TargetCallsigns[3] and ATCtarget == nil then 
					ATCtarget = myLivingUnit
				elseif  ATCtarget == nil then
					ATCtarget = myLivingUnit  
				end
			end
		end
		if Group.getByName(EnemyEscort) ~= nil and ATCtarget == nil then -- check if escorts are alive
			for index, data in pairs(Group.getByName(EnemyEscort):getUnits()) do
				local myLivingUnit = Unit.getName(data)	
				ATCtarget = myLivingUnit  
				--if Debugging == true then  printDebug ( "EventHandler" , "Escort " .. myLivingUnit, 10 ) end
			end
		end
		
		if TargetHold.wing == nil then myTargetAltString = "" end
		if TargetHold.hasspawned == nil then 
		
			local myConvertedAlt = TargetHold.alt
			if PlayerAircraft.altimeter == "meters" then myConvertedAlt = myConvertedAlt/FEET end 
			
			local myTargetAltString = "at " .. string.format("%d", myConvertedAlt) .. " " .. PlayerAircraft.altimeter:sub(1,1):upper() .. PlayerAircraft.altimeter:sub(2) .. " MSL " 
			if TargetHold.wing == "rotary" then myTargetAltString = "at " .. string.format("%d", myConvertedAlt)  .. " " .. PlayerAircraft.altimeter:sub(1,1):upper() .. PlayerAircraft.altimeter:sub(2) .. " AGL " 
			elseif TargetHold.wing == nil then myTargetAltString = "" end -- ground target don't tell them its in the air
		
			if TargetHold.follow == nil then -- only if player not following wingman
				local myStrangeNoise = ""
				if SomethingFailed == true then
					myStrangeNoise = "You heard a strange noise from your aircraft. Return to base or ignore the problem\n"
				end
				TargetHold.text = myStrangeNoise .. "Fly heading: " .. string.format("%03d", TargetHold.bearing)  .." for target type: " .. TargetHold.typename .. TargetHold.andtext .." ".. myTargetAltString .. "Distance: " .. string.format("%.1f" , TargetHold.distance*MILES) .. " miles." 
								end
		elseif TargetHold.hasspawned == true and ATCtarget ~= nil then
			if WingmanAlive == true and PlayerAircraft.shooting == true then PlayerAircraft.shooting = false end -- want to reset the attack variable for wingman if tripped
			
			if Targets[string.upper(Unit.getTypeName(Unit.getByName(ATCtarget)):gsub('[%p%c%s]', '') )] == nil then 
				TargetHold.typename = ATCtarget 
			else 
				TargetHold.typename = Targets[string.upper(Unit.getTypeName(Unit.getByName(ATCtarget)):gsub('[%p%c%s]', '') )].type
				if Targets[string.upper(Unit.getTypeName(Unit.getByName(ATCtarget)):gsub('[%p%c%s]', '') )].typename ~= nil then TargetHold.typename = Targets[string.upper(Unit.getTypeName(Unit.getByName(ATCtarget)):gsub('[%p%c%s]', '') )].typename end 
			end
			TargetHold.alt = getMSLfeet(ATCtarget)
			if TargetHold.wing == "rotary" then TargetHold.alt = getAGLfeet(ATCtarget) end
			TargetHold.alt = math.floor(TargetHold.alt/250 + 1 * 0.5) * 250 -- ROUND TO NEAREST THOUSAND
			local myConvertedAlt = TargetHold.alt
			
			
			-- CONVERT IF PLAYER AIRCRAFT ALTIMETER IS IN METERS
			local myAltMeters = myConvertedAlt/FEET
			myAltMeters = math.floor(myAltMeters /100+ 1 * 0.5) * 100
			if PlayerAircraft.altimeter == "meters" then myConvertedAlt = myAltMeters end 
			
			

			local myTargetAltString = "at " .. string.format("%d", myConvertedAlt) .. " " .. PlayerAircraft.altimeter:sub(1,1):upper() .. PlayerAircraft.altimeter:sub(2) .. " MSL " 
			if TargetHold.wing == "rotary" then myTargetAltString = "at " .. string.format("%d", myConvertedAlt)  .. " " .. PlayerAircraft.altimeter:sub(1,1):upper() .. PlayerAircraft.altimeter:sub(2) .. " AGL "  
			elseif TargetHold.wing == nil then myTargetAltString = "" end -- ground target don't tell them its in the air
			
			TargetHold.bearing = getBearingToGroup(PlayerName ,  ATCtarget )
			TargetHold.text = "Cleared to fire on " .. TargetHold.typename .. ". Bearing " .. string.format("%03d", TargetHold.bearing) .. " from you. Distance " .. string.format("%.1f" , TargetHold.distance*MILES) .. " miles " .. myTargetAltString
		end
		if TargetHold.text ~= nil and ATCtarget ~= nil then -- should we be telling the player something
			doPrintThis ({clearview = ClearText , duration= 30 , text=TargetHold.text })
		end
		if ATCtarget == nil then TargetHold.visible = false end -- no more targets stop running this loop
	end
	-- 
	if ( myDistanceToTarget < (TriggerDistance*PlayerAircraft.targetmod) ) and TargetHold.hasspawned == nil then 
		-- if Debugging == true then  printDebug ( "EventHandler" , PlayerName  .. " is close enough to " .. TargetHold.callsign .. " at " .. myDistanceToTarget, 10 ) end
		TargetHold.hasspawned = true
		SpawnCombatTarget (  )
	end
	if SmokeOnTarget == true and ( myDistanceToTarget < ((TriggerDistance*1.5)*PlayerAircraft.targetmod) ) and TargetHold.smoke == nil then 
		local mySmokePosition = getPointOnRadian ( { diameter=50 , pos=TargetHold.spawnposition , angle = math.random(1,6)} )
		mySmokePosition.y = land.getHeight{x = mySmokePosition.x, y = mySmokePosition.z}
		trigger.action.smoke(mySmokePosition , 1 )
		TargetHold.smoke = true
	end 

end

-- EVENT LOOP FOR PLAYER RTB
if TargetHold.rtb ~= nil and PlayerAlive == true and (math.fmod (timer.getTime(), 60 )  < 1 )then
	local myBearing = getBearingToPoint (PlayerName , Airbase.getPoint(Airbase.getByName(PlayerAircraft.airbase.name)))
	local myDistance = getDistanceBetweenUnitAndPoint (PlayerName , Airbase.getPoint(Airbase.getByName(PlayerAircraft.airbase.name)))
	local myText = gThingsToSay.atc.flyheading .. " " .. string.format ( "%03d" , myBearing) .. " for " .. string.format("%.1f ", myDistance*MILES) .. "miles to return to " .. PlayerAircraft.airbase.name 
	if PlayerAircraft.saythisonce == nil then 
		myText = gThingsToSay.atc.targetsdestroyed .. ". " .. myText 
	end 
	PlayerAircraft.saythisonce = true
	if PlayerAircraft.airbase.category ~= 1 then myText = myText .. " " .. gThingsToSay.atc.airbase end 
	doPrintThis ({clearview = ClearText , duration= 30 , text=myText  })
end 

-- EVENT LOOP IF PLAYER IS FORMING UP WITH THE WINGMAN
if (PlayerAircraft.formation.joinup) == true and ( math.fmod (timer.getTime(), 20 ) < 1 ) and PlayerAlive == true and WingmanAlive == true then
	-- if Debugging == true then  printDebug ( "EventHandler" , "Joinup Event Loop", 10 ) end
	PlayerAircraft.formation.currentdistance = getDistanceBetweenUnits( PlayerName, Wingman )
	local myPlayerAGL = getAGL ( PlayerName )
	local myWingmanAGL = getAGL ( Wingman )
 
	-- ARE THEY CLOSE ENOUGH TO WINGMAN?
	if ( PlayerAircraft.formation.currentdistance <= PlayerAircraft.formation.hseperation  ) then
		PlayerAircraft.formation.closeenough = true	
	else
		PlayerAircraft.formation.closeenough = false	
		PlayerAircraft.formation.winguptime = nil
	end
	
	-- ARE THEY IN THE ALT RANGE OF WINGMAN?
	if ( myWingmanAGL - myPlayerAGL > (-1*PlayerAircraft.formation.vseperation ) and myWingmanAGL - myPlayerAGL < PlayerAircraft.formation.vseperation ) then
		PlayerAircraft.formation.altrange = true
	else 
		PlayerAircraft.formation.altrange = false
		PlayerAircraft.formation.winguptime = nil 
		-- if Debugging == true then  printDebug ( "EventHandler" , "Player not at alt of " .. Wingman .. " leading.", 10 ) end
	end
	
	if PlayerAircraft.formation.altrange == true and PlayerAircraft.formation.closeenough == true and PlayerAircraft.formation.winguptime == nil then
		-- if Debugging == true then  printDebug ( "EventHandler" , "Player has started the alt and range of wingman" , 10 ) end

		doPrintThis ({clearview = ClearText , duration= 30 , text= Wingman .. ": In range. Now stay in tight formation with me." })
		PlayerAircraft.formation.winguptime = timer.getTime()
		PlayerAircraft.formation.randomtime = math.random ( 10 , 30 )
	end
	
	if ( PlayerAircraft.formation.altrange == true and PlayerAircraft.formation.closeenough == true and PlayerAircraft.formation.winguptime ~= nil ) or OverRide == true then

		if (  timer.getTime() -  PlayerAircraft.formation.winguptime ) > PlayerAircraft.formation.randomtime then
			-- if Debugging == true then  printDebug ( "EventHandler" , "Player has been in range for long enough" , 10 ) end
			if PlayerAircraft.formation.intercept == nil then
				local myHeading = doGetUnitHeading ( {callsign=Wingman} )
				local myPos = specificGroupCircle ( Wingman , 50000 , myHeading.angle )  --  given group diameter and angele get two points from that group	
				doPrintThis ({clearview = ClearText , duration= 30 , text=Wingman .. ": Wings level"  })
				local myRoute = {}
				myRoute[#myRoute+1] = { type = "Turning Point" , action = "Fly Over Point" , pointX=myPos.x , pointZ=myPos.z , alt = WingmanHoldAlt  , altType="RADIO" , speed=PlayerAircraft.formation.slowest }
				local myInfo = { unit = Wingman , route=myRoute , push=true }
				timer.scheduleFunction(doScheduleFlyRoute, myInfo, timer.getTime()+ 1 )
				PlayerAircraft.formation.nextwaypoint = TargetHold.spawnposition 		
				PlayerAircraft.formation.hseperation = FormationDistance
				PlayerAircraft.formation.vseperation = FormationAlt
				PlayerAircraft.formation.intercept = true
				
				timer.scheduleFunction(doWingmanClimbOut, myInfo, timer.getTime()+ 20 )
				PlayerAircraft.formation.joinup = nil

			end
		end
	else
		if( math.fmod (timer.getTime(), 30 ) < 1 ) then
			doPrintThis ({clearview = ClearText , duration= 30 , text= Wingman .. ": Close to less than " .. PlayerAircraft.formation.hseperation .. " meters. You are " .. string.format("%d", PlayerAircraft.formation.currentdistance ) .. " meters away"  })
			TargetHold.text = nil
		end
	end
end

-- EVENT LOOP FOR PLAYER FLYING IN FORMATION
if (PlayerAircraft.formation.active) == true and ( math.fmod (timer.getTime(), 10 ) < 1 ) and PlayerAlive == true and WingmanAlive == true then
	-- if Debugging == true then  printDebug ( "EventHandler" , "Formation Loop", 10 ) end
	PlayerAircraft.formation.currentdistance = getDistanceBetweenUnits( PlayerName, Wingman )
	if TrailWingmanAlive == true then
		PlayerAircraft.formation.traildistance = getDistanceBetweenUnits( PlayerName, TrailWingman )
		if PlayerAircraft.formation.traildistance > 500 then
			local myLivery = AircraftType[PlayerAircraft.key].rlivery
			if AircraftType[PlayerAircraft.key].flivery ~= nil then myLivery = AircraftType[PlayerAircraft.key].flivery end 
			local myPlayerHeading = doGetUnitHeading ({ callsign=PlayerName} )
			--if Debugging == true then  printDebug ( "EventHandler" , "Wingman Heading: " .. myPlayerHeading.bearing , 10 ) end
			local TrailReverseHeading = GetReverseBearing (myPlayerHeading.bearing ) -- reverse because we are spawing behind wingman
			local myAngle = TrailReverseHeading.bearing * math.pi/180 -- we are spawning downwind from player
			local my6clock = specificGroupCircle ( PlayerName , 100 , myAngle)  --  given group diameter and angele get two points from that group
			local myTrailSpawn = {
						callsign=TrailWingman ,
						type=PlayerAircraft.type ,
						speed=doGetVelocity (PlayerName) , -- start out slower than normal 
						alt = getMSLfeet(PlayerName) ,
						country="USA" ,
						spawnfrom = "Airborne",
						position=my6clock,
						skill= "Good",
						parking=2,
						livery=myLivery ,
						lateActivation = false ,
						wing=PlayerAircraft.wing,
						heading = myPlayerHeading.bearing ,
						task = "Nothing" ,
						}
			mySpawnAirplane (myTrailSpawn)
			local myInput = { lead=PlayerName , trail = TrailWingman , center=-10 , above=1 , behind=-10,}
			timer.scheduleFunction(doFollowFormation, myInput, timer.getTime()+ 5 )
		end
	end
	local myPlayerAGL = getAGL ( PlayerName )
	local myWingmanAGL = getAGL ( Wingman )
	local mySartingSpeed = PlayerAircraft.formation.speed 
	 
	local myWingmanSpeed = doGetVelocity (Wingman )
	--if Debugging == true then  printDebug ( "EventHandler" , "Distance " ..  string.format("%d", PlayerAircraft.formation.currentdistance), 2 ) end
	-- ARE THEY CLOSE ENOUGH TO WINGMAN?
	if ( PlayerAircraft.formation.currentdistance <= PlayerAircraft.formation.hseperation  ) then
		PlayerAircraft.formation.closeenough = true	
	else
		PlayerAircraft.formation.closeenough = false	
		PlayerAircraft.formation.winguptime = nil
	end
	
	-- ARE THEY IN THE ALT RANGE OF WINGMAN?
	if ( myWingmanAGL - myPlayerAGL > (-1*PlayerAircraft.formation.vseperation ) and myWingmanAGL - myPlayerAGL < PlayerAircraft.formation.vseperation ) then
		PlayerAircraft.formation.altrange = true
	else 
		PlayerAircraft.formation.altrange = false
		PlayerAircraft.formation.winguptime = nil 
		-- if Debugging == true then  printDebug ( "EventHandler" , "Player not at alt of " .. Wingman , 10 ) end
	end
	
	if PlayerAircraft.formation.altrange == true and PlayerAircraft.formation.closeenough == true and PlayerAircraft.formation.winguptime == nil then
		-- if Debugging == true then  printDebug ( "EventHandler" , "Player has started the alt and range of wingman" , 10 ) end
		PlayerAircraft.formation.winguptime = timer.getTime()
		PlayerAircraft.formation.randomtime = math.random ( 40 , 80 )
	end
	
	-- WHAT TO DO IF THEY HAVE BEEN IN RANGE FOR LONG ENOUGH
	if PlayerAircraft.formation.altrange == true and PlayerAircraft.formation.closeenough == true and PlayerAircraft.formation.winguptime ~= nil then
		if (  timer.getTime() -  PlayerAircraft.formation.winguptime ) > PlayerAircraft.formation.randomtime then
			-- if Debugging == true then  printDebug ( "EventHandler" , "Player has been in range for long enough" , 10 ) end
			
	
			if ( PlayerAircraft.formation.alt ~= PlayerAircraft.formation.targetAlt  ) then
				PlayerAircraft.formation.speed = mySartingSpeed -- any speed adjustment gets undone.  We just want to climb
				timer.scheduleFunction(formationAdjustSpeed, PlayerAircraft.formation, timer.getTime()+ 5 )	
				doPrintThis ({clearview = ClearText , duration= 30 , text=Wingman .. ": Climb to " .. string.format("%d", PlayerAircraft.formation.alt + PlayerAircraft.formation.altIncrease)  .. " maintain heading"   })

			elseif ( (PlayerAircraft.formation.speed+1) <= PlayerAircraft.speed )  then --IF WE STILL CAN INCREASE SPEED and not waiting for trail 	
				PlayerAircraft.formation.speed = PlayerAircraft.formation.speed + PlayerAircraft.formation.speedrange
				formationAdjustSpeed (PlayerAircraft.formation )
				-- if Debugging == true then  printDebug ( "EventHandler" , "Player met range requirement. Speed up " .. string.format("%d", PlayerAircraft.formation.speedrange)  .. " kph to " .. string.format("%d", PlayerAircraft.formation.speed) , 10 ) end
				local myRealSpeed = myWingmanSpeed + PlayerAircraft.formation.speedrange
				TargetHold.text = Wingman .. ": Keep close while I increase ground speed to " ..  string.format("%d", PlayerAircraft.formation.speed ) .. " knots"
				doPrintThis ({clearview = ClearText , duration= 30 , text=TargetHold.text  })
				-- THERE IS ANOTHER AIRCRAFT IN TOW
			elseif (PlayerAircraft.formation.skipHeading == nil ) then -- THEY ARE FAST ENOUGH AND TURNING ALLOWED 		
				PlayerAircraft.formation.nextwaypoint = randomUnitCircle ( Wingman , 1000000 ) --  given a group and diameter random position on that circle from that group
				local myTurnInformation = doGroupHeadingTurn ( {callsign=Wingman , speed=PlayerAircraft.formation.speed ,  alt=PlayerAircraft.formation.alt , altType="RADIO" , delay=7 , diameter = 5000 , point=PlayerAircraft.formation.nextwaypoint} )	
				-- THERE IS ANOTHER AIRCRAFT IN TOW
				doPrintThis ({clearview = ClearText , duration= 30 , text=Wingman .. ": Turn " .. myTurnInformation.direction .. " To heading " .. myTurnInformation.heading })			
			end
			PlayerAircraft.formation.winguptime = nil	-- RESET THE CHECKTIME
			PlayerAircraft.formation.inrange = true -- set the range to true
		end 
	else
		if( math.fmod (timer.getTime(), 30 ) < 1 ) then
			doPrintThis ({clearview = ClearText , duration= 30 , text= Wingman .. ": Close to less than " .. PlayerAircraft.formation.hseperation .. " meters. You are " .. string.format("%d", PlayerAircraft.formation.currentdistance ).. " meters away" })		
		end
	end

	-- WHAT TO DO IF THEY ARE OUT OF RANGE
	if PlayerAircraft.formation.currentdistance > (PlayerAircraft.formation.hseperation*3) and PlayerAircraft.formation.inrange ~= nil then
		PlayerAircraft.formation.speed = PlayerAircraft.formation.slowest
		formationAdjustSpeed (PlayerAircraft.formation)
		PlayerAircraft.formation.inrange = nil
		doPrintThis ({clearview = ClearText , duration= 30 , text=Wingman .. ": I am slowing to ground speed of " .. string.format("%d", PlayerAircraft.formation.speed) .. ". Stay within " .. PlayerAircraft.formation.hseperation .. " meters of me"   })
		-- if Debugging == true then  printDebug ( "EventHandler" , Wingman .. " is slowing down to " .. string.format("%d", PlayerAircraft.formation.slowest) , 10 ) end
	end
	
end	

-- EVENT LOOP FOR AIR TRAFFIC CONTROL
if ( gTrafficPatterns.atc ~= nil and ( math.fmod (timer.getTime(), 10 ) < 1 ) ) then
		
		-- if Debugging == true then  printDebug ( "EventHandler" , "ATC Active", 10 ) end	
		-- if gTrafficPatterns.traffic ~= nil then
			-- if Debugging == true then  printDebug ( "EventHandler" , "Other traffic in the pattern " .. gTrafficPatterns.traffic, 10 ) end
			doRadarSweep ()
		-- end
		
		-- player given position and hold?
		if gTrafficPatterns.playerPositionHold ~= nil and gTrafficPatterns.radar.runway ~= nil  then	
			-- if Debugging == true then  printDebug ( "EventHandler" , "Player should get position and hold", 10 ) end
			timer.scheduleFunction(ATCSaySomething, {text=gThingsToSay.atc.positionhold  .. " " .. gTrafficPatterns.airfield.active , talking="tower" , who=PlayerName} , timer.getTime()+ math.random(1,3) )
			gTrafficPatterns.playerReadyTakeoff = PlayerName
			gTrafficPatterns.playerPositionHold  = nil 
			doATCmenu ({action = gTrafficPatterns.atcinstructs.taxiparking})
		end
		
		if gTrafficPatterns.playerHeldLanding ~= nil and gTrafficPatterns.radar.landing == nil then	
			-- if Debugging == true then  printDebug ( "EventHandler" , "Player should get position and hold", 10 ) end
			timer.scheduleFunction(ATCSaySomething, {text=gThingsToSay.atc.positionhold .. " " .. gTrafficPatterns.airfield.active, talking="tower" , who=PlayerName} , timer.getTime()+ math.random(1,3) )
			gTrafficPatterns.playerHeldLanding = nil 
			gTrafficPatterns.playerPositionHold = PlayerName 
			doATCmenu ({action = gTrafficPatterns.atcinstructs.taxiparking})
		end
		
		if gTrafficPatterns.playerReadyTakeoff ~= nil and gTrafficPatterns.radar.runway == nil then	
			-- if Debugging == true then  printDebug ( "EventHandler" , "Player should get takeoff", 10 ) end
			timer.scheduleFunction(ATCSaySomething, {text=gThingsToSay.atc.takeoff .. " " .. gTrafficPatterns.airfield.active, talking="tower" , who=PlayerName} , timer.getTime()+ math.random(1,3) )
			local mySpeechDelay = math.random ( 1,4 )
			timer.scheduleFunction( myATCSpeak , {[1] = gThingsToSay.sound.takeoff , } , timer.getTime()+ mySpeechDelay  )
			myCheckLandingTraffic (gTrafficPatterns.atcinstructs.toland)
			gTrafficPatterns.playerReadyTakeoff = nil	
			doATCmenu ({action = gTrafficPatterns.atcinstructs.taxiparking})
		end
		
		if PlayerAlive == true then
			-- if Debugging == true then  printDebug ( "EventHandler" , "AGL: " .. string.format("%d " , gTrafficPatterns.playerpos.altAGL) .. "MSL: " .. string.format("%d " , gTrafficPatterns.playerpos.altMSL) ..  "Dist Appr: " .. string.format("%.1f " , gTrafficPatterns.playerpos.disapproach) ..  "Dist Depart: " .. string.format("%.2f " , gTrafficPatterns.playerpos.disdeparture) , 5 ) end
			-- if Debugging == true then  printDebug ( "EventHandler" , "Dpeart Angle " ..  string.format("%.2f " ,gTrafficPatterns.airfield.arriveangle)  .. "Arrive Angle " ..  string.format("%.2f " ,gTrafficPatterns.airfield.departangle)  .."Angle Approach: " .. string.format("%.2f " , gTrafficPatterns.playerpos.angleapproach) .. "Angle Depart: " .. string.format("%.2f " , gTrafficPatterns.playerpos.angledepart), 5 ) end
					-- gTrafficPatterns.playerpos.disapproach = getDistanceBetweenUnitAndPoint( PlayerName, myStartingPos )
					-- gTrafficPatterns.playerpos.disdeparture = getDistanceBetweenUnitAndPoint( PlayerName, myDepartPos )
					-- gTrafficPatterns.playerpos.angleapproach = getAngleBetweenTwoPoints(centerUnitCoordinates ( PlayerName ) , myStartingPos)
					-- gTrafficPatterns.playerpos.andgledepart  = getAngleBetweenTwoPoints(centerUnitCoordinates ( PlayerName ) , myDepartPos)
					-- gTrafficPatterns.playerpos.altAGL = getAGL(PlayerName)
					-- gTrafficPatterns.playerpos.altMSL = getMSLmeters(PlayerName)
					
					-- gTrafficPatterns.playerpos.altMSL = getMSLmeters(PlayerName)
			local myPlayerDistance = getDistanceBetweenUnitAndPoint( PlayerName, gTrafficPatterns.airfield.point)

		
			-- if Debugging == true then  printDebug ( "EventHandler" , "Player AGL " .. gTrafficPatterns.playerpos.altAGL , 10 ) end
			if myPlayerDistance >= gPatternDistance and gTrafficPatterns.playerinuncontrolled == nil and gTrafficPatterns.playerpos.altAGL >5 then --and gTrafficPatterns.playerpos.altAGL > 5 and gTrafficPatterns.playerpos.altAGL < 457 then
				-- if Debugging == true then  printDebug ( "EventHandler" , "Player in uncontrolled " .. myPlayerDistance , 5 ) end
				doATCmenu ({action=gTrafficPatterns.atcinstructs.inbound})
				gTrafficPatterns.playerinuncontrolled = true
				gTrafficPatterns.playercontrolled = nil
			end 
			if myPlayerDistance <= gPatternDistance and gTrafficPatterns.playercontrolled == nil and gTrafficPatterns.playerpos.altAGL >5 then --and gTrafficPatterns.playerpos.altAGL > 5 and gTrafficPatterns.playerpos.altAGL < 457 then
				-- if Debugging == true then  printDebug ( "EventHandler" , "Player in controlled " .. myPlayerDistance , 5 ) end
				doATCmenu ({action=gTrafficPatterns.atcinstructs.toland})
				gTrafficPatterns.playerinuncontrolled = nil
				gTrafficPatterns.playercontrolled = true
			end 
			
			myLandingTraffic = nil 
			if gTrafficPatterns.radar.final ~= nil then myLandingTraffic = gTrafficPatterns.radar.final end
			if gTrafficPatterns.radar.geardown ~= nil then myLandingTraffic = gTrafficPatterns.radar.geardown end
			if gTrafficPatterns.radar.landing ~= nil then myLandingTraffic = gTrafficPatterns.radar.landing end
			
		
			-- if myLandingTraffic ~= nil then
				-- local myClockDir = getClockBearingUnitToUnit ( PlayerName , myLandingTraffic )
				-- if Debugging == true then  printDebug ( "EventHandler" , myLandingTraffic .. " is at " .. PlayerName .. " " .. myClockDir .. " oclock position"    , 5 ) end

				-- -- local myPlayerHeading = doGetUnitHeading ( {callsign=PlayerName, } )
				-- -- local myAngleTarget = getAngleBetweenTwoPointsV2(centerUnitCoordinates ( PlayerName ) , centerUnitCoordinates ( myLandingTraffic )) -- TOOLBOX FUNCTION
				-- -- local myDifference =  (((math.pi*2 - myPlayerHeading.angle ) + myAngleTarget) * 1.9098593171027440292266051604702)
				-- -- local myRemainder = myDifference % math.floor(myDifference) 
				-- -- if myDifference % math.floor(myDifference)  >= .5 then myDifference = math.ceil ( myDifference ) else myDifference = math.floor ( myDifference ) end
				-- -- if myDifference > 12 then myDifference = myDifference - 12 end
				-- -- if Debugging == true then  printDebug ( "EventHandler" , "Player is angle " .. string.format("%.1f" , myPlayerHeading.angle ) .. " To target " .. string.format("%.1f" , myAngleTarget ) .. " Difference " .. string.format("%d" ,myDifference) .. " " ..  string.format("%.3f" , myRemainder )  , 5 ) end
			-- end

			-- if gTrafficPatterns.playerpos.onfinal ~= nil then --and gTrafficPatterns.playerpos.altAGL > 5 and gTrafficPatterns.playerpos.altAGL < 457 then
				-- if Debugging == true then  printDebug ( "EventHandler" , "Player Inside Final Box at. " .. myPlayerDistance*MILES , 5 ) end
			-- end 
			-- if gTrafficPatterns.playerpos.onbase ~= nil then --and gTrafficPatterns.playerpos.altAGL > 5 and gTrafficPatterns.playerpos.altAGL < 457 then
				-- if Debugging == true then  printDebug ( "EventHandler" , "Player Inside base Box" .. myPlayerDistance*MILES, 5 ) end
			-- end
			-- if gTrafficPatterns.playerpos.ondownwind ~= nil then --and gTrafficPatterns.playerpos.altAGL > 5 and gTrafficPatterns.playerpos.altAGL < 457 then
				-- if Debugging == true then  printDebug ( "EventHandler" , "Player Inside downwind Box." .. myPlayerDistance*MILES, 5 ) end
			-- end
			-- if gTrafficPatterns.playerpos.oncrosswind  ~= nil then
				-- if Debugging == true then  printDebug ( "EventHandler" , "Player upwind." .. myPlayerDistance*MILES, 5 ) end		
			-- end
			-- if gTrafficPatterns.playerpos.straightin  ~= nil then
				-- if Debugging == true then  printDebug ( "EventHandler" , "Player straight in." .. myPlayerDistance*MILES, 5 ) end		
			-- end
			--- WIND DIRECTIONS

		end 

		
end

-- EVENT LOOP FOR EXAM MENU
if gCheckRide.active ~= nil and PlayerAlive == true  then 
	-- if Debugging == true then  printDebug ( "EventHandler" , "in this loop", 10 ) end
	
	-- if ( math.fmod (timer.getTime(), 5 ) < 1 )  then
		
		-- if Debugging == true then  printDebug ( "EventHandler" , Unit.getLife(Unit.getByName(PlayerName) ), 10 ) end
	-- end 
	
	-- 	EVERY 30 SECONDS CHECK TO KKEEP SAYING TO PLAYER
	if gCheckRide.active ~= nil and PlayerAlive == true and ( math.fmod (timer.getTime(), 30 ) < 1 )  then
		if gCheckRide.keepsaying ~= nil and gCheckRide.rogerthat == nil and gCheckRide.failedsingle == nil then myKeepSaying (  ) end
	end
	
	-- EVENT LOOP FOR DEMONSTRATION OF SKILLS
	if PlayerAlive == true and gPerformance[PlayerAircraft.type] ~= nil then

		local myAircraftParams = gPerformance[PlayerAircraft.type]
		
		-- TAXI TO ACTIVE
		if gCheckRide.taxi ~= nil then
			local myMSL = getMSLmeters ( PlayerName )
			local myPlayerHeadingTable = doGetUnitHeading ({callsign=PlayerName})
			local myDistanceToActive = getDistanceBetweenUnitAndPoint( PlayerName, gCheckRide.runway.threshold )
			-- if Debugging == true then  printDebug ( "EventHandler" , "Distance to active " .. myDistanceToActive , 10 ) end
			-- if Debugging == true then  printDebug ( "EventHandler" , "Bearing "  .. myPlayerHeadingTable.bearing .. " Runway " .. gCheckRide.runway.bearing ..  " Distance Active " .. myDistanceToActive  , 10 ) end
			if doGetVelocity ( PlayerName ) < .5 and myDistanceToActive < 100 and myPlayerHeadingTable.bearing > ( gCheckRide.runway.bearing - 9 ) and myPlayerHeadingTable.bearing < ( gCheckRide.runway.bearing + 9 ) then 
				--if Debugging == true then  printDebug ( "EventHandler" , "Heading "  .. myPlayerHeadingTable.bearing .. " Runway " .. gCheckRide.taxi.runway.bearing ..  " Distance Active " .. myDistanceToActive  , 10 ) end	
				gCheckRide.exam[gCheckRide.menus.taxi] = "Pass"
				gCheckRide.taxi = nil
				doScore ()
			end 
			-- if Debugging == true then  printDebug ( "EventHandler" , "Heading "  .. myPlayerHeadingTable.bearing .. " Distance Active " .. myDistanceToActive  , 10 ) end	
		end 
		--- SHORTFIELD --	
		if gCheckRide.shortfield ~= nil then
			local myDistanceToActive = getDistanceBetweenUnitAndPoint( PlayerName, gCheckRide.shortfield.start  )
			-- doPrintThis ({clearview = myClearView  , duration= 30 , text=gCheckRide.say.remaining .. string.format(" %d meters" , myAircraftParams.takeoff -  myDistanceToActive) })

			if Unit.getByName(PlayerName):inAir() == true then
				if PlayerAircraft.wing == "rotary" then 
					if Debugging == true then printDebug ("EventHandler" , "Watching for takeoff" , 10 ) end
				end 
				if getAGL(PlayerName) > (gCheckRide.shortfield.basealt) + gCheckRide.shortfield.airborneheight then 
					--if Debugging == true then  printDebug ( "EventHandler" , "Distance From "  .. myDistanceToActive  , 10 ) end
					local myPassFail = "Fail" 
					local myText = gCheckRide.say.shortfieldfail
					gCheckRide.exam[gCheckRide.menus.shortfield] = myPassFail
					if myDistanceToActive <= gCheckRide.shortfield.distance then
						myPassFail = "Pass" 
						myText = gCheckRide.say.shortfieldpass 
						gCheckRide.exam[gCheckRide.menus.shortfield] = myPassFail				
					end 
					local myConversionDistance = myConvertUnitOfMeasure ( { method=gPerformance[PlayerAircraft.type].altimeter , distance=gCheckRide.shortfield.distance, } )
					local myConversionScore = myConvertUnitOfMeasure ( { method=gPerformance[PlayerAircraft.type].altimeter , distance=myDistanceToActive, } )
					myText = myPassFail ..  " " .. myText .. " " .. myConversionDistance.distance.. " " .. myConversionDistance.method .. ". " .. gCheckRide.say.ittookyou ..string.format(" %d " ,  myConversionScore.distance) .. myConversionScore.method
					local myScheduleTime = math.random(2,4)
					timer.scheduleFunction(doPrintThis, {clearview = true  , duration= 30 , text=myText }, timer.getTime()+ myScheduleTime )

					gCheckRide.shortfield = nil
					timer.scheduleFunction(doScore, nil ,timer.getTime()+ myScheduleTime +.5 ) 
				end
			end
		end
		--- STALLS --
		-- if gCheckRide.stall.current == gCheckRide.menus.poweroffstall or gCheckRide.stall.current == gCheckRide.menus.poweronstall then 
		if gCheckRide.stall ~= nil then 
			local myClearView = true
			local myPerformance = getAirspeed ( PlayerName )
			local myStallSpeed = myAircraftParams.poweronstall
			local myCorrectedMSL = myPerformance.msl+(myPerformance.msl*0.0207135915955351 )

			if gCheckRide.stall.current == gCheckRide.menus.poweroffstall then
				myStallSpeed = myAircraftParams.poweroffstall
			end 
			local myRecoverspeed = myStallSpeed	+ 1
			local myStallSpeedAdj = myStallSpeed - ( myPerformance.msl * 0.0049212598425197 )
	 
			-- if Debugging == true then  printDebug ( "EventHandler" , "Airspeed "  .. myPerformance.airspeed .. " AGL " .. myCorrectedMSL .. " Stall " .. myStallSpeed .. " Adj " .. myStallSpeedAdj , 10 ) end	
			if myPerformance.airspeed  <= myStallSpeedAdj and gCheckRide.stall.stallalt == nil and Unit.getByName(PlayerName):inAir() then 
				doPrintThis ({clearview = myClearView  , duration= 10 , text=gCheckRide.say.stallonset  })
				-- if Debugging == true then  printDebug ( "EventHandler" , "There is the stall" , 10 ) end
				gCheckRide.stall.stallalt = myPerformance.msl
				gCheckRide.stall.lowestalt = 0 
				gCheckRide.keepsaying = nil 
			end
			 
			if gCheckRide.stall.stallalt ~= nil then
				if myPerformance.msl > gCheckRide.stall.stallalt then gCheckRide.stall.stallalt = myPerformance.msl end 
			
				local myPitchAndRoll = doGetPitchAndRoll ( {callsign=PlayerName} ) -- USED FOR GENERAL SPACIAL AWARENESS OF AIRCRAFT
				-- if Debugging == true then  printDebug ( "EventHandler" , myPitchAndRoll.roll .. " " .. myPitchAndRoll.pitch , 10 ) end
				if (gCheckRide.stall.stallalt - myPerformance.msl) >  gCheckRide.stall.lowestalt then gCheckRide.stall.lowestalt = gCheckRide.stall.stallalt - myPerformance.msl end 
				if (myPitchAndRoll.velocity > myRecoverspeed ) and (myPitchAndRoll.roll == "Level" and myPitchAndRoll.pitch == "Level" ) then 
					-- if Debugging == true then  printDebug ( "EventHandler" , "Starting to track the the recovery" , 10 ) end
					local myAltLoss = gCheckRide.stall.lowestalt 
					local myPassFail = gCheckRide.say.fail
					local myText = gCheckRide.say.unspecifiedfailure
					if gCheckRide.stall.stallalt < (gCheckRide.stall.demoalt  - gCheckRide.globals.stallaltlimits) then
						myPassFail = gCheckRide.say.fail
						myText = gCheckRide.say.wrongentry
					else
						if myAltLoss > gCheckRide.stall.recoveryalt  then myPassFail = gCheckRide.say.fail else myPassFail = gCheckRide.say.pass end
						local myConversion = myConvertUnitOfMeasure ( { method=gPerformance[PlayerAircraft.type].altimeter , distance=myAltLoss, } )
						local myConversionLimit = myConvertUnitOfMeasure ( { method=gPerformance[PlayerAircraft.type].altimeter , distance=gCheckRide.globals.stallrecoverylimit, } )
						
						myText = gCheckRide.say.recoverystatus .. string.format(" %d " ,myConversion.distance ) .. myConversion.method .. ". " .. gCheckRide.say.thelimitwas .. " " .. myConversionLimit.distance .. " " .. myConversion.method
					end
					
					
					doPrintThis ({clearview = myClearView  , duration= 30 , text=myPassFail .. " " .. myText })
					gCheckRide.exam[gCheckRide.stall.current] = myPassFail
					gCheckRide.stall = nil
					doScore ()
				end
			end

		end
		--- STRAIGHT AND LEVEL --	
		if gCheckRide.straightlevel ~= nil then
			local myMSL = getMSLmeters ( PlayerName )
			myMSL = myMSL + (myMSL* 0.021)
			local myPlayerHeadingTable = doGetUnitHeading ({callsign=PlayerName})
			local myHeadingRange = false
			local myAltRange = false 
			
			-- doPrintThis ({clearview = myClearView  , duration= 1 , text="Player Alt" .. " " .. string.format("%d" , myMSL) .. "Target Alt" .. gCheckRide.straightlevel.alt }) 
			
			if myPlayerHeadingTable.bearing >= gCheckRide.straightlevel.lowheading and myPlayerHeadingTable.bearing <= gCheckRide.straightlevel.highheading then
				myHeadingRange = true
			end
			if myMSL >= gCheckRide.straightlevel.lowalt and myMSL <= gCheckRide.straightlevel.highalt then
				myAltRange = true
			end

			if myHeadingRange == true and myAltRange == true then
				-- if Debugging == true then  printDebug ( "EventHandler" , "In range " .. myMSL , 10 ) end
				if gCheckRide.straightlevel.inrangestart == nil then
					gCheckRide.straightlevel.inrangestart = timer.getTime()
					-- if Debugging == true then  printDebug ( "EventHandler" , "Starting Tracking " , 10 ) end
					gCheckRide.straightlevel.attempts = gCheckRide.straightlevel.attempts + 1
				elseif gCheckRide.straightlevel.inrangestart ~= nil then
					if timer.getTime() > gCheckRide.straightlevel.inrangestart+ gCheckRide.straightlevel.inrangefor and gCheckRide.straightlevel.inrangewatch  == nil then
						-- local myText = gCheckRide.say.maintainingalt .. " " .. gCheckRide.straightlevel.convertedalt .. " " .. gCheckRide.say.maintainingheading .. " " .. 
						-- string.format("%d",gCheckRide.straightlevel.heading) .. " " .. gCheckRide.say.sayfor .. " " .. gCheckRide.straightlevel.maintainfor .. " " .. gCheckRide.say.seconds
						doPrintThis ({clearview = ClearText  , duration= 10 , text=gCheckRide.straightlevel.instruct })
						--if Debugging == true then  printDebug ( "EventHandler" , "In range long enough start watching" , 10 ) end
						gCheckRide.straightlevel.inrangewatch  = timer.getTime()
						gCheckRide.straightlevel.tryagain = nil 
						gCheckRide.keepsaying = nil
					end
					if gCheckRide.straightlevel.inrangewatch ~= nil and timer.getTime() > gCheckRide.straightlevel.inrangestart+gCheckRide.straightlevel.maintainfor then
						gCheckRide.exam[gCheckRide.menus.straightlevel] = "Pass"
						gCheckRide.straightlevel = nil
						local myText = gCheckRide.say.pass .. " " .. gCheckRide.say.straightlevelpass
						doPrintThis ({clearview = ClearText  , duration= 30 , text=myText })
						--timer.scheduleFunction(doPrintThis, {clearview = false  , duration= 10 , text=gCheckRide.say.wingslevel }, timer.getTime()+ 5 )					
						doScore ()
						-- gCheckRide.straightlevel.inrangestart = nil 
						-- gCheckRide.straightlevel.inrangewatch  = nil
					end
				end
		
			elseif gCheckRide.straightlevel.attempts > 2 then
						gCheckRide.exam[gCheckRide.menus.straightlevel] = "Fail"
						gCheckRide.straightlevel = nil
						local myText = gCheckRide.say.fail .. " " .. gCheckRide.say.straightlevelfail
						doPrintThis ({clearview = ClearText  , duration= 30 , text=myText })
					--	timer.scheduleFunction(doPrintThis, {clearview = false  , duration= 10 , text=gCheckRide.say.wingslevel }, timer.getTime()+ 5 )
						doScore ()
						-- gCheckRide.straightlevel.inrangestart = nil 
						-- gCheckRide.straightlevel.inrangewatch  = nil
			else
				-- if Debugging == true then  printDebug ( "EventHandler" , "Not in range " .. myMSL , 10 ) end

				if gCheckRide.straightlevel.tryagain == nil and gCheckRide.straightlevel.inrangestart ~= nil then
					gCheckRide.straightlevel.tryagain = timer.getTime()
					doPrintThis ({clearview = ClearText  , duration= 10 , text=gCheckRide.say.tryagain .. " " .. gCheckRide.straightlevel.instruct }) 
				end
				gCheckRide.straightlevel.inrangestart = nil 
				gCheckRide.straightlevel.inrangewatch  = nil			
			end

		end 
		--- TURNS AROUND A POINT --
		if gCheckRide.turnsaroundpoint ~= nil then
			local myClearView = true
			-- if Debugging == true then  printDebug ( "EventHandler" , "Turns around a point" , 10 ) end
			local myDistanceToActive = getDistanceBetweenUnitAndPoint( PlayerName, gCheckRide.turnsaroundpoint.point )

			if (gCheckRide.turnsaroundpoint.marktime + 120 ) < timer.getTime() then --REDRAW SMOKE DUE TO TIME
				gCheckRide.turnsaroundpoint.marktime = timer.getTime()
				trigger.action.smoke(gCheckRide.turnsaroundpoint.point , 1 )
				-- if Debugging == true then  printDebug ( "EventHandler" , "Smoke On" , 10 ) end
			end
			
			if myDistanceToActive <= gCheckRide.turnsaroundpoint.distancewatch and gCheckRide.turnsaroundpoint.inrangestart == nil then

			
				local myText = gCheckRide.say.letsbegin .." "..  gCheckRide.say.flyhold .." " .. gCheckRide.say.nocloser .. " " .. gCheckRide.turnsaroundpoint.textrangeclose.distance .. " " ..gCheckRide.turnsaroundpoint.textrangeclose.method .. " " .. gCheckRide.say.nofurther .. " " .. gCheckRide.turnsaroundpoint.textrangefar.distance .. " " .. gCheckRide.turnsaroundpoint.textrangefar.method
				doPrintThis ({clearview = myClearView  , duration= 10 , text=myText })
				gCheckRide.turnsaroundpoint.inrangestart = timer.getTime()
				local myStartHeading = doGetUnitHeading ({callsign=PlayerName})
				gCheckRide.turnsaroundpoint.startangle = myStartHeading.angle 
				local myReverseAngle = GetReverseAngle (gCheckRide.turnsaroundpoint.startangle )
				gCheckRide.turnsaroundpoint.reverseangle = myReverseAngle.angle
				gCheckRide.keepsaying = nil

			end 
			
			if gCheckRide.turnsaroundpoint.inrangestart ~= nil then
				local myCurrentHeading = doGetUnitHeading ({callsign=PlayerName})
				local myText = gCheckRide.say.toofar
				gCheckRide.turnsaroundpoint.samplecount = gCheckRide.turnsaroundpoint.samplecount + 1
				-- if Debugging == true then  printDebug ( "EventHandler" , myDistanceToActive , 10 ) end
				if myDistanceToActive >= gCheckRide.turnsaroundpoint.closest and myDistanceToActive <= gCheckRide.turnsaroundpoint.furthest then
					myText = gCheckRide.say.inrange
					gCheckRide.turnsaroundpoint.inrangecount= gCheckRide.turnsaroundpoint.inrangecount + 1
				elseif myDistanceToActive < gCheckRide.turnsaroundpoint.closest then 
					myText = gCheckRide.say.tooclose
				end 
				if ( math.fmod (timer.getTime(), 5 ) < 1 ) then 
					if myText ~= gCheckRide.say.inrange then
						local myConversion = myConvertUnitOfMeasure ( { method=gPerformance[PlayerAircraft.type].altimeter , distance=myDistanceToActive, } )
						myText = myText .. ". " .. gCheckRide.say.yourdistance .. string.format(" %d " , myConversion.distance ) .. myConversion.method .. ". " .. gCheckRide.say.shouldbebetween .. " ".. gCheckRide.turnsaroundpoint.textrangeclose.distance
						.. " ".. gCheckRide.say.sayand .. " " .. gCheckRide.turnsaroundpoint.textrangefar.distance .. " " .. gCheckRide.turnsaroundpoint.textrangefar.method

					end
					doPrintThis ({clearview = myClearView  , duration= 5 , text=myText }) 
					
		 
				end  
				
				-- if gCheckRide.turnsaroundpoint.halfway == nil and  myCurrentHeading.angle <= gCheckRide.turnsaroundpoint.reverseangle + .2 and myCurrentHeading.angle >= gCheckRide.turnsaroundpoint.reverseangle - .2 then
				if gCheckRide.turnsaroundpoint.halfway == nil and angleInRange( gCheckRide.turnsaroundpoint.reverseangle - .2  , gCheckRide.turnsaroundpoint.reverseangle + .2 , myCurrentHeading.angle )then
					doPrintThis ({clearview = myClearView  , duration= 5 , text="180 degrees completed" })
					gCheckRide.turnsaroundpoint.halfway = true
				end
				if gCheckRide.turnsaroundpoint.halfway ~= nil  and gCheckRide.turnsaroundpoint.full == nil and angleInRange( gCheckRide.turnsaroundpoint.startangle - .2  , gCheckRide.turnsaroundpoint.startangle + .2 , myCurrentHeading.angle )then
					local myPercentInRange = gCheckRide.turnsaroundpoint.inrangecount/gCheckRide.turnsaroundpoint.samplecount

					local myPassFail = gCheckRide.say.fail 
					if myPercentInRange > gCheckRide.turnsaroundpoint.passpercent then 
						myPassFail = gCheckRide.say.pass
					end
					gCheckRide.exam[gCheckRide.menus.turnsaroundpoint] = myPassFail
					myText = myPassFail .. ". " .. gCheckRide.say.percentinrange ..  string.format(" %d" , myPercentInRange*100) .. "%. " .. gCheckRide.say.shouldbegreater .. " " .. gCheckRide.turnsaroundpoint.passpercent*100 .. "%"
					doPrintThis ({clearview = myClearView  , duration= 10 , text=myText })
					gCheckRide.turnsaroundpoint.full = true
					gCheckRide.turnsaroundpoint = nil
					doScore ()
				end
				
					
					
				-- if gCheckRide.turnsaroundpoint.halfway ~= nil and gCheckRide.turnsaroundpoint.full == nil and myCurrentHeading.angle <= gCheckRide.turnsaroundpoint.startangle then
					-- doPrintThis ({clearview = myClearView  , duration= 5 , text="Turn was 360 degres" })
					-- gCheckRide.turnsaroundpoint.full = true
				-- end
				
			end
			

			
			-- gCheckRide.turnsaroundpoint.distancewatch = myDistanceToActive + 10
			-- gCheckRide.turnsaroundpoint.furthest = myDistanceToActive + 1000
			
			
			
		end
		-- STEEP TURNS --
		if gCheckRide.steepturns ~= nil then
			local myClearView = true

			local myInput = {}
			myInput.unit = PlayerName
			myInput.lowheading = gCheckRide.steepturns.lowheading
			myInput.highheading = gCheckRide.steepturns.highheading
			myInput.lowalt = gCheckRide.steepturns.lowalt
			myInput.highalt = gCheckRide.steepturns.highalt
			
			local myCurrentMSL = getMSLmeters ( PlayerName )
			myCurrentMSL = myCurrentMSL + (myCurrentMSL* 0.021)
			
			-- IS PLAYER AT DESIRED HEADING AND ALT
			if gCheckRide.steepturns.started == nil then 
				local myWithinLimits = UnitAtDesiredHeadingAndAltitude (myInput)
				local myPitchAndRoll =  doGetPitchAndRoll ( {callsign=PlayerName} ) 
				if myWithinLimits.heading == true and myWithinLimits.altitude == true and (myPitchAndRoll.roll == "Level" and myPitchAndRoll.pitch == "Level" )  then

				--	if Debugging == true then  printDebug ( "EventHandler" , "Player within limits" , 10 ) end
					if gCheckRide.steepturns.inrangestart == nil then
						gCheckRide.steepturns.inrangestart = timer.getTime()
						doPrintThis ({clearview = myClearView  , duration= 5 , text=gCheckRide.say.wingslevel })
						gCheckRide.keepsaying = nil -- stop telling player what to do
					elseif gCheckRide.steepturns.inrangestart ~= nil then
						if timer.getTime() > gCheckRide.steepturns.inrangestart+ gCheckRide.steepturns.inrangefor and gCheckRide.steepturns.inrangewatch  == nil then
							-- local myText = gCheckRide.say.maintainingalt .. " " .. gCheckRide.straightlevel.convertedalt .. " " .. gCheckRide.say.maintainingheading .. " " .. 
							-- string.format("%d",gCheckRide.straightlevel.heading) .. " " .. gCheckRide.say.sayfor .. " " .. gCheckRide.straightlevel.maintainfor .. " " .. gCheckRide.say.seconds
							gCheckRide.keepsaying = {startsteepturns = true,}
							myKeepSaying ()
							gCheckRide.steepturns.inrangewatch  = timer.getTime()
						end	
					end 
				end
			end 
			-- PLAYER BEEN TOLD TO START TURN START TRACKING TURN
			if gCheckRide.steepturns.inrangewatch ~= nil then 
				local myPitchAndRoll =  doGetPitchAndRoll ( {callsign=PlayerName} ) 

				if gCheckRide.steepturns.started == nil then 
					if myPitchAndRoll.rollangle >= gCheckRide.steepturns.rightstart or myPitchAndRoll.rollangle <= gCheckRide.steepturns.leftstart and myPitchAndRoll.rollangle > 0 then
						--if Debugging == true then  printDebug ( "EventHandler" , "Starting Angle " .. string.format("%.02f", myPitchAndRoll.rollangle ), 10 ) end
						gCheckRide.steepturns.started  = timer.getTime() 
						
						local myStartHeading = doGetUnitHeading ({callsign=PlayerName})
						gCheckRide.steepturns.startangle = myStartHeading.angle 
						local myReverseAngle = GetReverseAngle (gCheckRide.steepturns.startangle )
						gCheckRide.steepturns.reverseangle = myReverseAngle.angle
				
				
						gCheckRide.keepsaying = nil -- stop telling player what to do
					end
				else
					gCheckRide.steepturns.count = gCheckRide.steepturns.samplecount + 1 
				end
			
				if (myPitchAndRoll.rollangle >= gCheckRide.steepturns.rightlow and myPitchAndRoll.rollangle <= gCheckRide.steepturns.righthigh 
					or myPitchAndRoll.rollangle >= gCheckRide.steepturns.leftlow and myPitchAndRoll.rollangle <= gCheckRide.steepturns.lefthigh )
					and ( myCurrentMSL >= gCheckRide.steepturns.lowalt and myCurrentMSL <= gCheckRide.steepturns.highalt)
					and ( myPitchAndRoll.rollangle > 0 ) and ( gCheckRide.steepturns.started ~= nil ) then
					--if Debugging == true then  printDebug ( "EventHandler" , "Turn Angle " .. string.format("%.02f", myPitchAndRoll.rollangle ), 10 ) end
					gCheckRide.steepturns.inrangecount = gCheckRide.steepturns.inrangecount + 1
					gCheckRide.steepturns.samplecount = gCheckRide.steepturns.samplecount + 1
				elseif gCheckRide.steepturns.started ~= nil then -- they are turning but not in range
					gCheckRide.steepturns.samplecount = gCheckRide.steepturns.samplecount + 1
				end			
			end 
			-- TURNS STARTED AND HAS MADE 180 PROGRESS
			if gCheckRide.steepturns.halfway == nil and gCheckRide.steepturns.started ~= nil then 
				local myCurrentHeading = doGetUnitHeading ({callsign=PlayerName})
				if angleInRange( gCheckRide.steepturns.reverseangle - .2  , gCheckRide.steepturns.reverseangle + .2 , myCurrentHeading.angle )then
					doPrintThis ({clearview = myClearView  , duration= 5 , text="180 degrees completed" })
					gCheckRide.steepturns.halfway = true
				end
			end
				-- TURNS STARTED AND HAS MADE 360 PROGRESS	
			if gCheckRide.steepturns.halfway ~= nil  and gCheckRide.steepturns.full == nil then 
				local myCurrentHeading = doGetUnitHeading ({callsign=PlayerName})
				if angleInRange( gCheckRide.steepturns.startangle - .2  , gCheckRide.steepturns.startangle + .2 , myCurrentHeading.angle )then
					doPrintThis ({clearview = myClearView  , duration= 5 , text="360 degrees completed" })
					gCheckRide.steepturns.full = true
				end
			end
			
			if gCheckRide.steepturns.full ~= nil then
				local myPitchAndRoll =  doGetPitchAndRoll ( {callsign=PlayerName} ) 
				if (myPitchAndRoll.roll == "Level" and myPitchAndRoll.pitch == "Level" ) then 
					local myCurrentHeading = doGetUnitHeading ({callsign=PlayerName})
					if myCurrentHeading.bearing >= gCheckRide.steepturns.lowheading and myCurrentHeading.bearing <= gCheckRide.steepturns.highheading
					and myCurrentMSL >= gCheckRide.steepturns.lowalt and myCurrentMSL >= gCheckRide.steepturns.highalt then
						--doPrintThis ({clearview = myClearView  , duration= 5 , text="Rolled out at heading and alt" })
					else
						--doPrintThis ({clearview = myClearView  , duration= 5 , text="Did not roll out at heading and alt" })
					end 
					--gCheckRide.steepturns.full = true

					local myPercent = gCheckRide.steepturns.inrangecount/gCheckRide.steepturns.samplecount
					local myPassFail = gCheckRide.say.fail 
					if myPercent >= gCheckRide.steepturns.passpercent then  
						myPassFail = gCheckRide.say.pass
					end
					local myText = myPassFail .. ". " .. gCheckRide.say.turnResult .. " " .. string.format("%d",myPercent*100) .. "%. " .. gCheckRide.say.shouldbegreater .. " " .. gCheckRide.steepturns.passpercent*100 .. "%"
					doPrintThis ({clearview = myClearView  , duration= 30 , text=myText })
					gCheckRide.exam[gCheckRide.menus.steepturns] = myPassFail
					--gCheckRide.steepturns.inrangewatch = nil
					gCheckRide.steepturns = nil 
					doScore ()
				end 
			end 
		
		end -- END OF STEEP TURNS
		if gCheckRide.landing ~= nil then
			if Unit.getByName(PlayerName):inAir() == false and gCheckRide.landing.watching ~= nil then
				gCheckRide.landing.touchdowndistance = getDistanceBetweenUnitAndPoint( PlayerName, gCheckRide.runway.threshold )
				gCheckRide.landing.thresholddistance = getDistanceBetweenUnitAndPoint( PlayerName, gCheckRide.runway.thresholdBegins )
				-- gCheckRide.landing.touchdowndistance = getDistanceBetweenUnitAndPoint( PlayerName, gCheckRide.runway.touchdownpoint )
				
				gCheckRide.landing.watching = nil
				-- LANDING ROUTINE HANDLED THROUGH EVENT HANDLER and function myExamPlayerLand ()
				--myExamPlayerLand()
				-- if Debugging == true then  printDebug ( "EventHandler" , "Touchdown "  .. gCheckRide.landing.touchdowndistance  , 10 ) end
			end
			if gCheckRide.landing.fullstop ~= nil and doGetVelocity ( PlayerName ) < .5 then
				-- if Debugging == true then  printDebug ( "EventHandler" , "Stopped ", 10 ) end
				doScore ()
				gCheckRide.landing = nil 
			end 
		end
		--- PERFORMANCE AIRSPEED
		if gCheckRide.perfairspeed ~= nil then
			local myPerformance = getAirspeed ( PlayerName )
			local myCorrectedMSL = myPerformance.msl+(myPerformance.msl*0.0207135915955351 )
			local myStallSpeedFlaps = myAircraftParams.poweroffstall
			local myStallSpeedClean = myAircraftParams.poweronstall
			local myStallSpeedAdjFlaps = myStallSpeedFlaps - ( myPerformance.msl * 0.0049212598425197 )
			local myStallSpeedAdjClean = myStallSpeedClean - ( myPerformance.msl * 0.0049212598425197 )
			local myText = "Curent Airspeed: "  .. string.format("%d",myPerformance.airspeed) .. " MSL: " .. string.format("%d",myCorrectedMSL) .. " Stall Full Flaps: " .. string.format("%d",myStallSpeedAdjFlaps) .. " Stall Clean: " .. string.format("%d",myStallSpeedClean) .. " " .. gCheckRide.say.atsealevel
			doPrintThis ({clearview = true  , duration= 1 , text=myText })
			
		end 
		--- PERFORMANCE TAKEOFF
		if gCheckRide.perftakeoff ~= nil then

			local myDistanceToActive = getDistanceBetweenUnitAndPoint( PlayerName, gCheckRide.perftakeoff.start  )
			-- doPrintThis ({clearview = myClearView  , duration= 30 , text= string.format(" %d meters" , myDistanceToActive ) })
			if Unit.getByName(PlayerName):inAir() == true then
				-- if Debugging == true then  printDebug ( "EventHandler" , PlayerAircraft.type , 10 ) end	
				myText = gCheckRide.say.ittookyou ..string.format(" %d " , myDistanceToActive *gUnitMeasureMod) .. gPrefUnitMeasure .. " " .. gCheckRide.say.totakeoff
				timer.scheduleFunction(doPrintThis, {clearview = myClearView  , duration= 30 , text=myText }, timer.getTime()+ math.random(2,4) )
				gCheckRide.perftakeoff = nil
			end
		end
		if gCheckRide.watchtakeoff ~= nil then
			-- if Debugging == true then  printDebug ( "EventHandler" , "Watch Takeoff "  .. getAGL(TrailWingman), 10 ) end
			local myDistanceToActive = getDistanceBetweenUnitAndPoint( TrailWingman, gCheckRide.watchtakeoff.start  )
			-- if Debugging == true then  printDebug ( "EventHandler" , "Distance From "  .. myDistanceToActive  , 10 ) end
			if Unit.getByName(TrailWingman):inAir() == true then
				if getAGL(TrailWingman) > (gCheckRide.watchtakeoff.basealt) + .5 then 
					--if Debugging == true then  printDebug ( "EventHandler" , PlayerAircraft.type , 10 ) end	
					myText = gCheckRide.say.ittookyou ..string.format(" %d " , myDistanceToActive *gUnitMeasureMod) .. gPrefUnitMeasure .. " " .. gCheckRide.say.totakeoff
					doPrintThis({clearview = myClearView  , duration= 30 , text=myText })
					gCheckRide.watchtakeoff = nil
				end 
			end
		end
		
	end -- END OF DEMONSTRATION LOOP
end

-- EVENT LOOP FOR AEROBATICS
if gAerobatics.active ~= nil and AerobaticsLeadAlive == true and PlayerAlive == true then	
	-- if Debugging == true then printDebug ("EventHandler" , "Aerobatics event loop active" , 10 ) end
		-- local myPoint =  gAerobatics.point
		-- if gMap == gMaps.normandy then myPoint = gAerobatics.holdinglegend end
		-- local myDistance = getDistanceBetweenUnitAndPoint( AerobaticsLead, myPoint )
		
	-- local myLocation = myPoint
	-- myLocation.y = land.getHeight{x = myLocation.x, y = myLocation.z}
	-- trigger.action.signalFlare(myLocation, 1, 1 )
	
		
	-- if Debugging == true and gAerobatics.saidgetready == nil then  printDebug ( "EventHandler" , string.format("%d", myDistance ) .. " meters away from start" , 1.1 ) end

	if gAerobatics.holding ~= nil and AerobaticsLeadAlive == true and ( math.fmod (timer.getTime(), 10 ) < 1 )  then
		-- if Debugging == true then printDebug ("EventHandler" , "Aerobatics holding active" , 10 ) end
		
		-- IS THE PLAYER CLOSE 
		gAerobatics.hseperation = 75
		gAerobatics.vseperation = 20
		gAerobatics.currentdistance = getDistanceBetweenUnits( PlayerName, AerobaticsLead )
		local myPlayerAGL = getAGL ( PlayerName )
		local myAerobaticsLeadAGL = getAGL ( AerobaticsLead )
		
			-- ARE THEY CLOSE ENOUGH TO AerobaticsLead?
		if ( gAerobatics.currentdistance <= gAerobatics.hseperation  ) then
			gAerobatics.closeenough = true		
		else
			gAerobatics.closeenough = false
			gAerobatics.winguptime = nil 
			gAerobatics.readytobegin = nil
			gAerobatics.saidgetready =	nil 
		end
		if ( myAerobaticsLeadAGL - myPlayerAGL > (-1*gAerobatics.vseperation ) and myAerobaticsLeadAGL - myPlayerAGL < gAerobatics.vseperation ) then
			gAerobatics.altrange = true		
		else
			gAerobatics.altrange = false
			gAerobatics.winguptime = nil
			gAerobatics.readytobegin = nil 	
			gAerobatics.saidgetready =	nil 		
		end
		if gAerobatics.altrange == true and gAerobatics.closeenough == true and gAerobatics.winguptime == nil then
		-- if Debugging == true then  printDebug ( "EventHandler" , "Player has started the alt and range of AerobaticsLead" , 10 ) end
			doPrintThis ({clearview = ClearText , duration= 30 , text= AerobaticsLead .. ": You are in range. Stay in close formation with me." })
			gAerobatics.winguptime = timer.getTime()
			gAerobatics.randomtime = math.random ( 10 , 30 )
		end
		
		if ( gAerobatics.altrange == true and gAerobatics.closeenough == true and gAerobatics.winguptime ~= nil ) or OverRide == true then
			if (  timer.getTime() -  gAerobatics.winguptime ) > gAerobatics.randomtime then
			
				local myCount = 0
				for n , value in pairs(gAerobatics.team) do
					local myDistance = getDistanceBetweenUnits( AerobaticsLead, value )
					if myDistance <= (gAerobatics.maxdistance*3) then 
						myCount = myCount + 1
					end
				end 
				if myCount >= #gAerobatics.team  then 
					if gAerobatics.readytobegin == nil then  
						doPrintThis ({clearview = ClearText , duration= 30 , text= AerobaticsLead .. ": Everyone stay in tight formation with me. Wait for my signal to begin aerobatics" })		
					end 
					gAerobatics.readytobegin = true 
				end
				
			end
		else
			if( math.fmod (timer.getTime(), 30 ) < 1 ) and Unit.getByName(PlayerName):inAir() and Unit.getByName(AerobaticsLead):inAir() then
				doPrintThis ({clearview = ClearText , duration= 30 , text= AerobaticsLead .. ": Close to less than " .. gAerobatics.hseperation .. " meters. You are " .. string.format("%d", gAerobatics.currentdistance ) .. " meters away"  })
			end
		end	
	end
	
	if gAerobatics.dogather ~= nil and AerobaticsLeadAlive == true and ( math.fmod (timer.getTime(), 5 ) < 1 ) then
		--if Debugging == true then printDebug ("EventHandler" , "Do Gather is active" , 10 ) end
		local myCount = 0
		for n , value in pairs(gAerobatics.team) do
			-- if Debugging == true then printDebug ("EventHandler" , "Checking for " .. value  , 10 ) end
			if Unit.isExist(Unit.getByName( value ) )  then 
						-- if Debugging == true then printDebug ("EventHandler" , "Checking Distance of " .. value  , 10 ) end
				local myDistance = getDistanceBetweenUnits( AerobaticsLead, value )
				local myAerobaticsLeadAGL = getAGL ( AerobaticsLead )
				local myAerobaticsLeadMSL = getMSLmeters ( AerobaticsLead )
				local myValueAGL = getAGL ( value )
				-- if Debugging == true then printDebug ("EventHandler" , myAerobaticsLeadMSL*FEET  .. " " .. gAerobatics.MSLalt*FEET.. " " .. math.abs(myAerobaticsLeadMSL*FEET - gAerobatics.MSLalt*FEET)  , 10 ) end
				--if Debugging == true then printDebug ("EventHandler" , value .. " " .. string.format("%d", myDistance)  .. " " .. gAerobatics.maxdistance .." " ..  string.format("%d",math.abs(myAerobaticsLeadAGL - myValueAGL)) .. " " .. gAerobatics.vertdistance, 10 ) end
				if myDistance <= gAerobatics.maxdistance and math.abs(myAerobaticsLeadAGL - myValueAGL) <= (20*(#gAerobatics.team-1)) and  ( math.abs(myAerobaticsLeadMSL - gAerobatics.MSLalt) <= 60 )  then 
					myCount = myCount + 1
					gAerobatics.timesinformation = gAerobatics.timesinformation + 1
				end 

			end 
		end

		if myCount >= #gAerobatics.team   then
			if gAerobatics.gatheruptime == nil then gAerobatics.gatheruptime = timer.getTime() end 

			if timer.getTime() > (gAerobatics.gatheruptime + 10)  then 

				if gAerobatics.status == "Gather" and gAerobatics.speedup ~= nil then
					timer.scheduleFunction(doTeamGatherUp , {sequence=gAerobatics.sequence , speedmod=1 , type="speedup" } , timer.getTime() + 1 )
					gAerobatics.gatheruptime = nil 
				else
					-- if Debugging == true then printDebug ("EventHandler" , "Number in range " .. myCount .. " number in team " ..  #gAerobatics.team , 10 ) end
					local myAerobaticsLeadSpeed = getAirspeed ( AerobaticsLead )
					--local myAdjustGatherSpeed = gAerobatics.gatherupspeed + ( myAerobaticsLeadSpeed.msl * gAerobatics.altadjustspeed  )
					-- if Debugging == true then printDebug ("EventHandler" , "Team gathered now " .. myAerobaticsLeadSpeed.airspeed , 10 ) end
					if math.floor(myAerobaticsLeadSpeed.airspeed) >= math.floor(gAerobatics.gatherupspeed-5) then -- gAerobatics.holdingspeed  then 
						gAerobatics.dogather = nil
						gAerobatics.gatheruptime = nil 
						gAerobatics.reminddistance = nil -- wait at least 30 seconds for out of formation before remind
						gAerobatics.startreminding = nil -- stop reminding out of formation
						resumeRoutine ()
					end
				end 
			end 
		elseif gAerobatics.startreminding ~= nil and ( math.fmod (timer.getTime(), 30 ) < 1 ) then
			local myAerobaticsLeadMSL = getMSLmeters ( AerobaticsLead )
			if math.abs(myAerobaticsLeadMSL - gAerobatics.MSLalt) <= 60 and gAerobatics.reminddistance ~= nil then 
				doPrintThis ({clearview = ClearText , duration= 10 ,  text= AerobaticsLead .. ": Close up. The entire team needs to be within " .. string.format("%d" , math.floor((gAerobatics.maxdistance*FEET)/25)*25) .. " feet of me" } )
			end 
			gAerobatics.reminddistance = true
		end
		
	
	end
	
	if gAerobatics.readytobegin ~= nil and gAerobatics.holding ~= nil and AerobaticsLeadAlive == true then
		local myDistance = getDistanceBetweenUnitAndPoint( AerobaticsLead, gAerobatics.point )
		if myDistance < 1000 and gAerobatics.saidgetready == nil then
			doPrintThis ({clearview = ClearText , duration= 30 , text=AerobaticsLead .. ": Approaching starting point"  })
			gAerobatics.saidgetready = true 
		end
		if myDistance < 100 then
			-- if Debugging == true then  printDebug ( "EventHandler" , "Begin routine" , 1.1 ) end
				gAerobatics.holding = nil
				gAerobatics.readytobegin = nil
				gAerobatics.saidgetready = nil
				doBeginRoutine ( input )
		end 

	end 
	
	if gAerobatics.performance ~= nil and AerobaticsLeadAlive == true then
		myPitchAndRoll = doGetPitchAndRoll ( {callsign=AerobaticsLead} )

		if gAerobatics.countdown ~= nil and math.fmod (timer.getTime(), 1 ) and gAerobatics.countdown - timer.getTime() then 	
			mySecondsRemaining = gAerobatics.countdown - timer.getTime()
			if mySecondsRemaining <= (gAerobatics.warning + 1 ) and (mySecondsRemaining >= 0) then 
				local myText = gAerobatics.text .. " in " .. math.floor (mySecondsRemaining) .. " seconds."
				if gAerobatics.countdown - timer.getTime() < 1 then myText = gAerobatics.initiatetext .. " now!" end 
				doPrintThis ({clearview = true , duration= 2 , text=myText })
				if mySecondsRemaining <= 6 then 
					if gAerobatics.smokeon == true and math.floor(mySecondsRemaining) < 1 then
						timer.scheduleFunction( myATCSpeak , {[1] = gThingsToSay.sound.smokeon , } , timer.getTime() + .1 )
						gAerobatics.smokeon = nil 
					else
						timer.scheduleFunction( myATCSpeak , {[1] = gThingsToSay.aerobatics[math.floor(mySecondsRemaining+1)] , } , timer.getTime() + .1 )
					end 
				end 
			end 
		end
		
		if  myPitchAndRoll.aerobatics_overall == "Level" and gAerobatics.gather_count == 2 and ( timer.getTime() >= gAerobatics.gatheruptime  ) then  
			gAerobatics.status = "Gather" 
			if gAerobatics.leveltime == nil then gAerobatics.leveltime = timer.getTime() + 5 end 
			--if Debugging == true then  printDebug ( "EventHandler" , AerobaticsLead .. " is level and maneuver is over"  , 2 ) end  
			if timer.getTime() >= gAerobatics.leveltime then 
				--timer.scheduleFunction(doTeamGatherUp , {sequence=gAerobatics.sequence , speedmod=.87 , type="gather" } , timer.getTime() + 2 )
				-- if Debugging == true then  printDebug ( "EventHandler" , AerobaticsLead .. " is level and maneuver is over gatherup "  , 2 ) end  
				
				timer.scheduleFunction(doTeamGatherUp , {sequence=gAerobatics.sequence , speedmod=gAerobatics.gatheruspeedmod , type="gather" } , timer.getTime() + gAerobatics.runout )
				--doTeamGatherUp ( {sequence=gAerobatics.sequence , speedmod=gAerobatics.gatheruspeedmod , type="gather" } ) 
				gAerobatics.leveltime = nil

				gAerobatics.gather_count = 0				
			end
		end
		
		if gAerobatics.maneuver_count < #gAerobatics.maneuverOrder and timer.getTime() >= gAerobatics.begintime then 
			--if Debugging == true then  printDebug ( "EventHandler" , AerobaticsLead .. " is about to perform Maneuver " .. gAerobatics.status  , 2 ) end  
			if myPitchAndRoll.aerobatics_overall == "Level" and gAerobatics.status == "Maneuver" then 
				
				--local myNextManeuver = gAerobatics.maneuverOrder[gAerobatics.maneuver_count].displayName
				--if Debugging == true then  printDebug ( "EventHandler" , AerobaticsLead .. " is about to perform Maneuver " .. myNextManeuver , 2 ) end  
				
				
				gAerobatics.status = "Level" 
				gAerobatics.starttime =  timer.getTime()
				
				local myManeuver = { id = "Aerobatics" , params = { ["maneuversSequency"] = {} , ["maneuversParams"] = {}, } }
				myManeuver.params.maneuversSequency[#myManeuver.params.maneuversSequency+1] = gAerobatics.maneuverOrder[gAerobatics.maneuver_count+1]
				myManeuver.params.maneuversSequency[#myManeuver.params.maneuversSequency+1] = gAerobatics.maneuverOrder[gAerobatics.maneuver_count+2]
				myManeuver.params.maneuversSequency[#myManeuver.params.maneuversSequency+1] = AerobaticsTypes({type="straightflight" , duration=100})
				
				gAerobatics.gather_count = gAerobatics.gather_count + 2
				gAerobatics.gatheruptime = timer.getTime() + gAerobatics.maneuverOrder[gAerobatics.maneuver_count+1].params.FlightTime.value + 5 
				gAerobatics.sequence = gAerobatics.sequence + 1
				
				gAerobatics.maneuver_count = gAerobatics.maneuver_count + 2
				

				
				gAerobatics.countdown = math.ceil(timer.getTime()+ (myManeuver.params.maneuversSequency[1].params.FlightTime.value) )
				gAerobatics.begintime = gAerobatics.countdown + 2
				
				local myDelay = .50
				--if myManeuver.params.maneuversSequency[2].name == "AILERON_ROLL" or myManeuver.params.maneuversSequency[2].name == "MILITARY_TURN" then myManeuver.params.maneuversSequency[1].params.FlightTime.value = myManeuver.params.maneuversSequency[1].params.FlightTime.value -1 end
				--if myManeuver.params.maneuversSequency[2].name == "MILITARY_TURN" then myManeuver.params.maneuversSequency[1].params.FlightTime.value = myManeuver.params.maneuversSequency[1].params.FlightTime.value -2 end

				--timer.scheduleFunction(doScheduleManeuver ,{group=AerobaticsLead, maneuver=myManeuver} , gAerobatics.countdown + myDelay  )
				timer.scheduleFunction(doScheduleManeuver ,{group=AerobaticsLead, maneuver=myManeuver} , timer.getTime() + myDelay )
				
				-- if Debugging == true then  printDebug ( "EventHandler" , AerobaticsLead .. ": perform a " .. myManeuver.params.maneuversSequency[2].displayName .. " in " .. gAerobatics.countdown-timer.getTime().. " seconds", 2 ) end 
				
				gAerobatics.text = AerobaticsLead .. ": perform a " .. myManeuver.params.maneuversSequency[2].displayName 
				gAerobatics.initiatetext = AerobaticsLead .. ": perform the " ..  myManeuver.params.maneuversSequency[2].displayName
				
				--- IS A SIDE OF THE AIRCRAFT PERFORMING THE MANEUVER ON
				if myManeuver.params.maneuversSequency[2].params.SIDE ~= nil then
					
					local mySide = " to the right"
					if myManeuver.params.maneuversSequency[2].params.SIDE.value == 0 then
						mySide = " to the left"
					end 
					gAerobatics.text = gAerobatics.text .. mySide
					gAerobatics.initiatetext = gAerobatics.initiatetext .. mySide
				end 
				
				-- IS THERE A ROLL DEGRESS
				if myManeuver.params.maneuversSequency[2].params.ROLL ~= nil then
					local myDegrees = myManeuver.params.maneuversSequency[2].params.ROLL.value 
					gAerobatics.text = gAerobatics.text .. " at " .. "degrees " .. myDegrees .. " roll"
				end
					
				-- IS THERE A DEGREE OF MOTION
				if myManeuver.params.maneuversSequency[2].params.SECTOR ~= nil then
					local myDegrees = myManeuver.params.maneuversSequency[2].params.SECTOR.value 
					gAerobatics.text = gAerobatics.text .. " for " .. myDegrees .. " degrees" 
				end
				
			elseif ( timer.getTime() >= gAerobatics.starttime+ 5 ) and ( myPitchAndRoll.aerobatics_overall ~= "Level" ) and gAerobatics.status == "Level"  then 
				-- if Debugging == true then  printDebug ( "EventHandler" , AerobaticsLead .. " is not level " .. myPitchAndRoll.pitchangle  , 2 ) end  
				gAerobatics.status = "Maneuver"			
				gAerobatics.countdown =	nil 		
			end 
			
		end 
 	

	end


end 

-- EVENT LOOP FOR RACING
if gAirRace.active ~= nil and PlayerAlive == true then

	-- if Debugging == true then printDebug ("EventHandler" , "In the loop" , 10 ) end
	
	local myStartFinishObjects = SearchAreaForObjects ( {point=gAirRace.start_finish , radius=1500 , category=Object.Category.UNIT ,  } )
	local myBackSideObjects = SearchAreaForObjects ( {point=gAirRace.back_course , radius=500 , category=Object.Category.UNIT ,  } )
	
	if myStartFinishObjects ~= nil  then

		for key , value in pairs(myStartFinishObjects) do
			
			if gAirRace.participants[value] ~= nil then 
				--if Debugging == true then printDebug ("EventHandler" , "In the loop " .. value , 10 ) end
				if gAirRace.participants[value].lap_counter == false then
					--local myDistance = getDistanceBetweenUnitAndPoint( value , gAirRace.start_finish )
					local myDistance = getDistanceBetweenUnitAndPoint( value , gAirRace.far_timing_point )
					local myTimingPoint = getDistanceBetweenUnitAndPoint( value , gAirRace.timing_point )
					
					if myDistance + myTimingPoint <= 2100  then
						if gAirRace.start_time == 0 then
							gAirRace.start_time = timer.getTime()
						end
						gAirRace.participants[value].lap = gAirRace.participants[value].lap + 1	
						gAirRace.participants[value].laps[gAirRace.participants[value].lap] = timer.getTime() - gAirRace.start_time - gAirRace.participants[value].split_time
						gAirRace.participants[value].split_time = timer.getTime() - gAirRace.start_time
						gAirRace.participants[value].lap_counter = true
						--if Debugging == true then printDebug ("EventHandler" ,  gAirRace.participants[value].name .." elapsed time " ..  gAirRace.participants[value].laps[gAirRace.participants[value].lap]  , 10 ) end
					end

					if myDistance + myTimingPoint <= 2100 and gAirRace.participants[value].lap == gAirRace.currentlap then
						local myShortestDistance = 10000
						local myWinner = ""
						local myRaceWinnerMeasurePoint = getPointOnRadian ( { diameter=2000 , pos=gAirRace.timing_point , angle = gAirRace.airbase_angle })
						gAirRace.currentlap = gAirRace.participants[value].lap + 1
						for winner_key , winner_value in pairs(gAirRace.participants) do
							--local myDistance = getDistanceBetweenUnitAndPoint( value , gAirRace.start_finish )
							local myDistance = getDistanceBetweenUnitAndPoint( value , gAirRace.far_timing_point )
							local myTimingPoint = getDistanceBetweenUnitAndPoint( value , gAirRace.timing_point )
							
							local myParticipantPoint = getPointOnRadian ( { diameter=myTimingPoint*2 , pos=myRaceWinnerMeasurePoint , angle = gAirRace.airbase_angle+(math.pi/2) })
							local myParticipantDistance = getDistanceBetweenUnitAndPoint( winner_key , myParticipantPoint )
							--if Debugging == true then printDebug ("EventHandler" ,  winner_key .." distance " .. myParticipantDistance   , 10 ) end
							if myParticipantDistance < myShortestDistance then
								gAirRace.raceleader = winner_key
								myShortestDistance = myParticipantDistance
							end 
						end
						--if Debugging == true then printDebug ("EventHandler" ,  gAirRace.racewinner .." Has won the race "   , 10 ) end
						gAirRace.leadgiven = true
					end 					
					
				end 
			end
		end
	end
	
	
	if myBackSideObjects ~= nil  then 
		for key , value in pairs(myBackSideObjects) do
			if gAirRace.participants[value] ~= nil then 
				if gAirRace.participants[value].back_course == nil then
					gAirRace.participants[value].start_finish = nil 
					gAirRace.participants[value].back_course = true
					
				end
			end 
		end 
	end
	
		-- Player GOING PAST EACH Cone
	for course_key , course_value in ipairs ( gAirRace.course ) do
		--if Debugging == true then printDebug ("EventHandler" ,  "checkkpoing  " .. course_key  , 10 ) end
		local myPassCheckpoint = SearchAreaForObjects ( {point=course_value , radius=gAirRace.gate_range , category=Object.Category.UNIT , ignore="Gate " .. course_key  } )
		if #myPassCheckpoint > 0 then
			--if Debugging == true then printDebug ("EventHandler" ,  "checkkpoing  " .. course_key  , 10 ) end
			for key , value in pairs(myPassCheckpoint) do


				if gAirRace.participants[value] ~= nil then 
					if course_key == 3 and gAirRace.participants[value].lap_counter == true then
						gAirRace.participants[value].lap_counter = false
						--if Debugging == true then printDebug ("EventHandler" ,  value .." starting on lap " .. gAirRace.participants[value].lap , 10 ) end
					end 
				end 
						
				-- DO WE NEED TO INCREASE PLAYER LAPS BY ONE
				if value == PlayerName and (course_key == 1 or course_key == 3 ) and gAirRace.player_waypoints.current_lap < (gAirRace.laps) then
					if course_key == 1 and gAirRace.player_lapcounter == false then 
						gAirRace.player_lapcounter = true
						gAirRace.player_waypoints.current_lap = gAirRace.player_waypoints.current_lap + 1
						gAirRace.player_waypoints.laps[gAirRace.player_waypoints.current_lap] = { gates = {} }
						myText = PlayerName .. " is on lap " ..  gAirRace.player_waypoints.current_lap
						doPrintThis ({clearview = ClearText  , group=PlayerName, duration= 30 , text=myText })
					elseif course_key == 3 and gAirRace.player_lapcounter == true then
						gAirRace.player_lapcounter = false
						-- if Debugging == true then printDebug ("EventHandler" ,  "Player cross start_finish " ..  gAirRace.player_waypoints.current_lap , 10 ) end
					end
				end
				
				
				if value == PlayerName and gAirRace.player_waypoints.laps[gAirRace.player_waypoints.current_lap].gates[course_key] == nil and gAirRace.player_waypoints.current_lap < (gAirRace.laps+1) then 
					--gAirRace.player_waypoints.gates[course_key] = true
					myText = PlayerName .. " flew within the range of gate " .. course_key .. " lap " .. gAirRace.player_waypoints.current_lap
					doPrintThis ({clearview = ClearText  , group=PlayerName, duration= 30 , text=myText })
					gAirRace.player_waypoints.laps[gAirRace.player_waypoints.current_lap].gates[course_key] = true
				end
			end 
		end 
	end
	
	if gAirRace.leadgiven ~= nil then
		if gAirRace.currentlap > (gAirRace.laps + 1 ) then 
			
			if gAirRace.player_provisional_winner == nil and gAirRace.player_waypoints.laps[1] ~= nil then 
				local myText = ""
				local missedGates = false 
				
				if gAirRace.player_waypoints.laps ~= nil then 
					for i=1,gAirRace.laps do
						local myMissedLaps = false
						-- if Debugging == true then printDebug ("EventHandler" ,  "Calculating Lap " .. i , 10 ) end
						for gate_key , gate_value in ipairs(gAirRace.course) do
							if gAirRace.player_waypoints.laps[i] ~= nil then -- player crossed a cone at least once
								if gAirRace.player_waypoints.laps[i].gates[gate_key] ~= nil then 
									--if Debugging == true then printDebug ("EventHandler" ,  "Went through lap " .. i .. " gate " .. gate_key , 10 ) end
								else
									--if Debugging == true then printDebug ("EventHandler" ,  "Missed lap" .. i .. " gate " .. gate_key , 10 ) end
									gAirRace.player_gate_penalty = gAirRace.player_gate_penalty + gAirRace.gate_penalty
									myText = myText .. " " .. gate_key .. ","
									missedGates = true -- we missed at least one gate
									myMissedLaps = true -- we missed at least one gate on this lap
								end
							end 
						end
						
						
						if myMissedLaps == true then -- only say the word lap if they missed a gate
							myText = "Lap " ..i .. " Gates" .. myText
						end 
						gAirRace.player_racetime= gAirRace.participants[PlayerName].split_time+gAirRace.player_gate_penalty
					end
				 
				
					if missedGates == true then 
						myText = myText:sub(1, #myText - 1)
						myText = "Player missed " .. myText ..  " and has a time penalty of " .. gAirRace.player_gate_penalty .. " seconds"
					else
						myText = "Player missed no gates"
					end

					doPrintThis ({clearview = true  , group=PlayerName, duration= 30 , text=myText })
						
				end
			end 
			
			if gAirRace.raceleader == PlayerName and gAirRace.player_gate_penalty > 0 then 
				gAirRace.player_provisional_winner = gAirRace.participants[PlayerName].split_time
				myText = PlayerName .. " is first to the line but has a " .. gAirRace.player_gate_penalty .. " second time penalty. For an elasped time of "  .. gAirRace.participants[PlayerName].split_time+gAirRace.player_gate_penalty .. " seconds."
				gAirRace.currentlap  = gAirRace.currentlap - 1 -- REMOVE LEADERS FINISH LAP
				gAirRace.leadgiven = nil
				
				doPrintThis ({clearview = false  , group=PlayerName, duration= 30 , text=myText })
				lostRacer ( PlayerName ) -- wait for the next AI to pass through gates
			else
				if gAirRace.player_racetime ~= nil then -- player finish time is calculated
					if ( gAirRace.player_racetime < gAirRace.participants[gAirRace.raceleader].split_time and gAirRace.player_waypoints.current_lap > gAirRace.laps ) or (missedGates == false and gAirRace.raceleader == PlayerName)  then 
						gAirRace.raceleader = PlayerName 
					end 
				end 
				myText = "The winner is " ..  gAirRace.raceleader .. " in an elapsed time of " .. gAirRace.participants[gAirRace.raceleader].split_time .. " seconds"
				doPrintThis ({clearview = false  , group=PlayerName, duration= 30 , text=myText })
				gAirRace.active = nil 
			end
			
			--gAirRace.active = nil
		elseif gAirRace.currentlap > gAirRace.laps then
			myText = "One lap to go! The Current Leader is " ..  gAirRace.raceleader 
			doPrintThis ({clearview = ClearText  , group=PlayerName, duration= 30 , text=myText })
			gAirRace.leadgiven = nil
		else
			myText = "The Current Leader is " ..  gAirRace.raceleader .. " on lap " .. gAirRace.participants[gAirRace.raceleader].lap .. " of " .. gAirRace.laps
			doPrintThis ({clearview = ClearText  , group=PlayerName, duration= 30 , text=myText })
			gAirRace.leadgiven = nil
		end

	end 
	
 
	
end 








